#!/usr/bin/perl

use CGI;

$CGI::POST_MAX = 100;
$CGI::DISABLE_UPLOADS = 1;

BEGIN {
	if ($ENV{QUERY_STRING} =~ /^instance=(\S+)$/) {
		$ENV{INSTANCE_NAME} = $1;
	}
}

use AbsenceConfig;
use AbsenceDB;

$DEF_CHUNKSIZE		= 6;
$MAIN_SCRIPT		= AbsenceConfig::fetch('main_script');
$MANAGE_SCRIPT		= AbsenceConfig::fetch('manage_script');
#$CONTROL_SCRIPT	= AbsenceConfig::fetch('control_script');
$TOP				= AbsenceConfig::fetch('data_dir_rel');
$VERSION			= '1.2';
$cookie_name = 'absence';

if (exists($ENV{INSTANCE_NAME})){
	$MAIN_SCRIPT .= "?instance=$ENV{INSTANCE_NAME}";
	$cookie_name = "absence-$ENV{INSTANCE_NAME}";
}

($month, $year) = (localtime(time))[4,5];
$month++;
$year += 1900;
$chunksize = $DEF_CHUNKSIZE;

$q = new CGI;
$q->import_names;

%cook = $q->cookie($cookie_name);

if (exists($cook{chunksize})) {
	$chunksize = $cook{chunksize};
}

$def_group_id = '';
if (exists($cook{group_id})) {
	$def_group_id = $cook{group_id};
}

print $q->header(),
	$q->start_html(-title => 'Absence', -target => 'display');

print $q->startform(-action => $MAIN_SCRIPT, -method => 'POST');
print "Show";
print $q->popup_menu(
	-name	=> 'chunksize',
	-values	=> [1..15],
	-default=> $chunksize,
);
print "Months. Start with ";
print $q->popup_menu(
	-name	=> 'start_month',
	-values	=> [1..12],
	-default=> $month,
);
print $q->popup_menu(
	-name	=> 'start_year',
	-values	=> [2002..2010],
	-default=> $year,
);
print $q->submit('action', 'SHOW ME!');
print $q->submit('action', 'Next');
print $q->submit('action', 'Previous');
print "Group";
my @groups = AbsenceDB::getGroups();
my $labref;
my $def;
foreach my $group_id (@groups) {
	$name = AbsenceDB::getGroupInfo($group_id);
	$labref->{$group_id} = $name;
}
print $q->popup_menu(
	-name		=> 'group_id',
	-values		=> \@groups,
	-default	=> $def_group_id,
	-labels		=> $labref,
);


if (exists($ENV{INSTANCE_NAME})) {
	$inst_str = qq[?instance=$ENV{INSTANCE_NAME}];
}
print qq[&nbsp;&nbsp;<A HREF="$MANAGE_SCRIPT$inst_str">Manage</A><BR>\n];
print $q->endform;
#print "<BR>cookie_name = [$cookie_name]\n";


print $q->end_html;
